public class Aufgabe3 {

    /*
    Aufgabe:
        Rekursive Methoden.
        Verändern Sie die Implementierungen der Methoden dieser Klasse entsprechend
        den Kommentaren an den mit TODO gekennzeichneten Stellen.

        Die Methoden sollen Ihr Ein-/Ausgabeverhalten auf gültigen Eingaben behalten.

        Der Programmcode soll OHNE SCHLEIFEN und OHNE GLOBALEN VARIABLEN
        (Variablen, die außerhalb eines Methodenrumpfs deklariert werden) auskommen!

        Die gegebenen Methodenköpfe sollen nicht verändert werden.
        Zusätzliche Hilfsmethoden sind nicht erlaubt.

    Punkte (maximal 20):
        8 Punkte für die Implementierung von 'dividers',
        6 Punkte für die Implementierung von 'f',
        6 Punkte für die Implementierung von 'printArray',
    */

    // liefert absteigend alle Teiler von n, die im Intervall i bis n-1 liegen,
    // durch ',' getrennt in einem String.
    // Vorbedingung: n > 0 und 1 < i < n
    public static String dividers2(int n, int i) {
        //TODO: Ersetzen Sie die Schleife durch Rekursion.
        String s = "";
        do {
            if (n%i == 0) {
                if (!s.equals("")) {
                    s = "," + s;
                }
                s = i + s;
            }
            i++;
        } while (i < n);
        return s;

    }
    public static String dividers(int n, int i) {
        if(n<=0||i>=n||1>=i){
            return "";
        }

        if(n%i==0){
            //keine Zeit mehr.. if abfrage die "," entfernt fehlt
            return  dividers(n,i+1) +","+ i  ;
        }else {

            return dividers(n,i+1);
        }

    }




    // return n < 0 ? f(-2*n,k) : n/(2*k);
    // Vorbedingung: k != 0
    public static int f2(int n, int k) {
        //TODO: Entfernen Sie die Rekursion.
        return n < 0 ? f2(-2*n,k) : n/(2*k);

    }
    public static int f(int n, int k) {
        //TODO: Entfernen Sie die Rekursion.
        return n < 0 ? n/(-k) : n/(2*k);

    }

    // Gibt alle Elemente aus 'array' mit den Indizes 'from' bis 'to' (inklusive)
    // in umgekehrter Reihenfolge mit Tabulator als Trennzeichen aus.
    // Vorbedingung: array != null, from und to sind gültige Indizes für die
    // gilt: from <= to.
    // Diese Methode soll ohne Schleife auskommen und ohne Aufruf von
    // Methoden aus java.util.Arrays.
    public static void printArray2(int[] array, int from, int to) {
        //TODO: Ersetzen Sie die Schleife durch Rekursion.
        do {
            System.out.print(array[to]+"\t");
        } while(from <= --to);

    }
    public static void printArray(int[] array, int from, int to) {
        //TODO: Ersetzen Sie die Schleife durch Rekursion.
        if(from>to){
            return;
        }
        printArray(array,from+1,to);

        System.out.print(array[from]+"\t");

    }

    // Diese Methode können Sie zum Testen nutzen. Geht nicht in die Beurteilung ein.
    public static void main(String[] args) {
        System.out.println(dividers2(10,2));
        System.out.println(dividers(10,2));

        System.out.println(f2(9,2));
        System.out.println(f(9,2));

        printArray2(new int[]{1,2,3},0,2);
        System.out.println();
        printArray(new int[]{1,2,3},0,2);
    }

}

